import os
from codeina import configure
from codeina.extern.log import log

class productFile:
    def __init__ (self):
        # use a default filename for installed packages
        self._filename = os.path.join (configure.USR_CODEINA, 'installed.packages')
        self._products = []
        log.log ('productfile', 'using file: %s' % self._filename)
        pass

    def get_filename (self):
        return self._filename

    def set_filename (self, filename):
        self._filename = filename

    def product_in_list (self, product_name):
        return product_name in self._products

    def product_add (self, product_name):
        # return False if product_name is already in list
        if product_name in self._products:
            log.debug ('productfile', '%s already installed' % product_name)
            return False
        self._products.append (product_name)
        return True

    def save (self):
        f = open (self._filename, 'w')
        for name in self._products:
            f.write (name + '\n')
        f.close ()

    def load (self):
        if os.path.exists (self._filename) and os.path.isfile (self._filename):
            self._products = [ line[:-1] for line in open (self._filename, 'r').readlines ()]
        else:
            self._products = []

    def product_count (self):
        return len(self._products)

    def product_quick_add (self, product_name):
        self.load ()
        res = self.product_add (product_name)
        self.save ()
        return res

    def installed_product_list (self):
        self.load ()
        return self._products
