import os

from codeina.extern.log import log

_rs = None

free_plugins = []
restricted_caps = []

def _get_all_nodes_with_name (root, name):
    nodes = []
    for child in root.childNodes:
        if child.nodeName == name:
            nodes.append (child)
    return nodes

def _add_all_text_childs_to (node, nodes):
    for c1 in node:
        for c2 in c1.childNodes:
            nodes.append (c2.nodeValue)

def _add_items (freeNode, caps_list, plugins_list):
    for node in freeNode:
        _add_all_text_childs_to (_get_all_nodes_with_name (node, 'caps'), caps_list)
        _add_all_text_childs_to (_get_all_nodes_with_name (node, 'plugin'), plugins_list)

if _rs == None:
    # Load the initial values from the xml file
    from codeina import configure
    filename = configure.restricted_products_xml ()
    if not os.path.exists (filename):
        log.info ('restricted', "can't find filename %s" % filename)
    else:
        from xml.dom.minidom import parse
        try:
            dom = parse (filename)
            root = dom.childNodes[0]
            dummy = []
            _add_items (_get_all_nodes_with_name(root, 'free'), dummy, free_plugins)
            _add_items (_get_all_nodes_with_name(root, 'restricted'), restricted_caps, dummy)
        except:
            log.info ('restricted', 'Failed to parse filename %s' % filename)
