# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.configure import make_icon_path 
from codeina.extern.log import log
import pynotify

import codeina

import pygtk
import gtk
import sys

NOTIFICATION_TIMEOUT = 10

def quit_cb (widget, button=None):
  log.debug ('notify', 'quiting notify without any action')
  gtk.main_quit ()
  sys.exit(0)

def upgrade_cb (widget, button=None):
  log.debug ('notify', 'starting up codeina main interface for an upgrade')
  gtk.main_quit ()
  import codeina.ui.igtk as ui
  from urllib import quote
  from codeina.myutils import build_matches_url
  from codeina.productfile import productFile
  url = build_matches_url() 
  url += '&files='+quote(':'.join(productFile ().installed_product_list ()))
  print url
  sys.exit(ui.FluendoShop(codeina_url = url)())

class CodeinaUpgradeNotification:
    
    def __init__(self):
        pass

    def __call__(self):
        if not pynotify.init("Codeina"):
          log.warning ('notify', 'Failed to init pynotify')
          return
        n = pynotify.Notification(self.dialog_title, self.create_msg())
        from codeina import configure
        n.set_icon_from_pixbuf (configure.get_codeina_icon(40))
        n.set_urgency(pynotify.URGENCY_NORMAL)
        n.set_timeout(NOTIFICATION_TIMEOUT * 1000)
        n.connect ('closed', quit_cb)
        n.add_action ('ignore', 'Ignore', quit_cb)
        n.add_action ('upgrade', 'Upgrade', upgrade_cb)
        if not n.show():
            log.warning ('notify', "Failed to send notification")
            return 1
        gtk.main ()
        return 0

class CodeinaNotification:

    def __init__(self):
        pass

    def __call__(self):
        if not pynotify.init("Codeina"):
          log.warning ('notify', 'Failed to init pynotify')
          return
        n = pynotify.Notification(self.dialog_title, self.msg)
        n.set_urgency(pynotify.URGENCY_NORMAL)
        n.set_timeout(NOTIFICATION_TIMEOUT * 1000)
        from codeina import configure
        n.set_icon_from_pixbuf (configure.get_codeina_icon(40))
        n.connect ('closed', quit_cb)
        n.add_action ('ignore', 'Ignore', quit_cb)
        if not n.show():
            log.warning ('notify', "Failed to send notification")
            return 1
        gtk.main ()
        return 0
