# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.extern.log import log

def _check_website (host, path):
    import httplib
    try:
        conn = httplib.HTTPConnection (host)
        conn.request ("GET", path)
    except:
        log.debug('web', 'failed to connect to %s%s' % (host, path))
        return False
    resp = conn.getresponse ()
    if resp.status in (200, 301, 302):
        return True
    log.info ('web', 'got response %d (expected 200, 301, or 302) from %s%s' % (resp.status, host, path))
    return False

def website_exists(url):
    """
        Check that the website with this url exists
    """
    log.log ('web', 'checking status of website: %s' % url)
    host = url
    path = '/'
    if url.startswith('file:///'):
        import os
        return os.path.isfile(url[7:])
    if '://' in url:
        host = url.split('://')[1]
    if '/' in host:
        path = '/' + '/'.join(host.split('/')[1:])
        host = host.split('/')[0]
    return _check_website (host, path)

